//
//  ColorConversion.h
//  16ToUICOLOR
//
//  Created by test on 15/12/14.
//  Copyright © 2015年 test. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
typedef struct {
    CGFloat r,g,b,a;//RGB：0-255，a：0-1；
}RGBAColor;
typedef struct {//hsba：0-1；
    CGFloat h,s,b,a;
}HSBAColor;
@interface ColorConversion : NSObject
#pragma mark HSB和RGB颜色互转
+ (RGBAColor)HSBTORGB:(HSBAColor)color;
+ (HSBAColor)RGBTOHSB:(RGBAColor)color;

#pragma mark - RGBA\HSBA合成RGBAColor\HSBAColor
+ (RGBAColor)RGBAColorMakeWithR:(CGFloat)R G:(CGFloat)G B:(CGFloat)B A:(CGFloat)A;
+ (HSBAColor)HSBAColorMakeWithH:(CGFloat)H S:(CGFloat)S B:(CGFloat)B A:(CGFloat)A;

#pragma mark - RGBA进制颜色值转16进制（数字、字符串）
+ (NSInteger)RGBToHEXNum:(RGBAColor)color;
+ (NSString*)RGBToHEXStr:(RGBAColor)color;

#pragma mark - HSB、RGB转UIcolor；
+ (UIColor*)RGBTOUIColor:(RGBAColor)color;
+ (UIColor*)HSBTOUIColor:(HSBAColor)color;

#pragma mark - UIcolor转HSB、RGB；
+ (HSBAColor)UIColorToHSBA:(UIColor*)color;
+ (RGBAColor)UIColorToRGBA:(UIColor*)color;

#pragma mark - 16进制（字串、数字）颜色转UIColor
+ (UIColor*)ConvertWithHEXStr:(NSString *)HEX  Alpha:(CGFloat)a;
+ (UIColor*)ConvertWithHEXNum:(NSInteger)HEX  Alpha:(CGFloat)a;
@end
