//
//  ColorConversion.m
//  16ToUICOLOR
//
//  Created by test on 15/12/14.
//  Copyright © 2015年 test. All rights reserved.
//

#import "ColorConversion.h"

@implementation ColorConversion


+ (RGBAColor)HSBTORGB:(HSBAColor)color
{
    return [ColorConversion UIColorToRGBA:[ColorConversion HSBTOUIColor:color]];
}
+ (HSBAColor)RGBTOHSB:(RGBAColor)color
{
    return [ColorConversion UIColorToHSBA:[ColorConversion RGBTOUIColor:color]];
}

+ (RGBAColor)RGBAColorMakeWithR:(CGFloat)R G:(CGFloat)G B:(CGFloat)B A:(CGFloat)A
{
    RGBAColor color;
    color.r = R;
    color.g = G;
    color.b = B;
    color.a = A;
    return color;
}
+ (HSBAColor)HSBAColorMakeWithH:(CGFloat)H S:(CGFloat)S B:(CGFloat)B A:(CGFloat)A
{
    HSBAColor color;
    color.h = H;
    color.s = S;
    color.b = B;
    color.a = A;
    return color;
}
+ (NSInteger)RGBToHEXNum:(RGBAColor)color
{
    return strtoul([[ColorConversion RGBToHEXStr:color] UTF8String],NULL ,16);
}
+ (NSString*)RGBToHEXStr:(RGBAColor)color
{
    return [NSString stringWithFormat:@"%02x%02x%02x",(int)color.r,(int)color.g,(int)color.b];
}
+ (UIColor*)RGBTOUIColor:(RGBAColor)color
{
    return [UIColor colorWithRed:color.r/255.0f green:color.g/255.0f blue:color.b/255.0f alpha:color.a];
}
+ (UIColor*)HSBTOUIColor:(HSBAColor)color
{
    return [UIColor colorWithHue:color.h saturation:color.s brightness:color.b alpha:color.a];
}
+ (HSBAColor)UIColorToHSBA:(UIColor*)color
{
    HSBAColor hcolor;
    [color getHue:&hcolor.h saturation:&hcolor.s brightness:&hcolor.b alpha:&hcolor.a];
    return hcolor;
}
+ (RGBAColor)UIColorToRGBA:(UIColor*)color
{
    RGBAColor rcolor;
    [color getRed:&rcolor.r green:&rcolor.g blue:&rcolor.b alpha:&rcolor.a];
    return rcolor;
}
+ (UIColor*)ConvertWithHEXStr:(NSString *)HEX  Alpha:(CGFloat)a
{
    if (HEX.length < 6) { return [UIColor clearColor];}
    NSString * hexstr = HEX.length == 7 && [[HEX substringToIndex:1] isEqualToString:@"#"] ? [HEX substringFromIndex:1] : HEX ;
    return [ColorConversion ConvertWithHEXNum:strtoul([hexstr UTF8String],NULL ,16) Alpha:a];
}
+ (UIColor*)ConvertWithHEXNum:(NSInteger)HEX  Alpha:(CGFloat)a
{ 
    return [[UIColor alloc]initWithRed:((HEX & 0xFF0000) >> 16)/255.0f green:((HEX & 0xFF00) >> 8)/255.0f  blue:(HEX & 0xFF)/255.0f alpha:a];
}
@end
